SystemOrganization addCategory: #'Collections-DoubleLinkedList'!

Object subclass: #DoubleLinkedList
	instanceVariableNames: 'head tail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-DoubleLinkedList'!

!DoubleLinkedList commentStamp: '<historical>' prior: 0!
A DoubleLinkedList is a linked list where each element has two pointers, previous and next. The implementation is based on the conventional Linked List and doesn't support index-based access.

Instance Variables
	firstNode:		<Object>
	lastNode:		<Object>

firstNode
	- xxxxx

lastNode
	- xxxxx
!

!DoubleLinkedList methodsFor: 'adding' stamp: 'AnkeshAnand 12/24/2013 23:47'!
add: aNode
	"Add a node to the end of the Linked List."
	head ifNil: 
		[ head := aNode.
		  tail := aNode.
		  ^aNode. ].
	
	tail next: aNode.
	aNode previous: tail.
	tail := aNode.
	^aNode.
	
	! !

!DoubleLinkedList methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:28'!
head
	^head ! !

!DoubleLinkedList methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:29'!
head: aNode
	head := aNode! !

!DoubleLinkedList methodsFor: 'utility' stamp: 'AnkeshAnand 12/25/2013 00:52'!
isEmpty
	^ head == nil.! !

!DoubleLinkedList methodsFor: 'instance creation' stamp: 'AnkeshAnand 12/25/2013 00:57'!
new
	^super new initialize.! !

!DoubleLinkedList methodsFor: 'removing' stamp: 'AnkeshAnand 12/25/2013 23:38'!
remove: aNode ifAbsent: aBlock
	"This method removes the specified element from the list and returns the block if the element is not present."
	| current |
	head == aNode
		ifTrue: [ head := aNode next.
			tail == aNode
				ifTrue: [ tail := aNode previous . ].
			^aNode.].
	current := head.
	[ current == nil ifTrue: [^aBlock value]. current next == aNode] whileFalse: [ current := current next ].
	tail == aNode 
		ifTrue:
			 [ current next: nil. tail := aNode previous .]
		ifFalse:
			[ current next: aNode next . aNode next previous: current].
	^aNode.
	
		
			
		
		! !

!DoubleLinkedList methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:28'!
tail
	^tail! !

!DoubleLinkedList methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:30'!
tail: aNode
	tail := aNode! !

Object subclass: #DoubleLinkedListNode
	instanceVariableNames: 'next previous value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-DoubleLinkedList'!

!DoubleLinkedListNode commentStamp: '<historical>' prior: 0!
A DoubleLinkedListNode is a node(or an element) in the doubly linked list.

Instance Variables
	next:		<Object>
	previous:		<Object>
	value:		<Object>

next
	- xxxxx

previous
	- xxxxx

value
	- xxxxx
!

!DoubleLinkedListNode methodsFor: 'instance creation' stamp: 'AnkeshAnand 12/24/2013 23:16'!
new
	^super new initialize.! !

!DoubleLinkedListNode methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:13'!
next
	^next ! !

!DoubleLinkedListNode methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:13'!
next: aNode
	next := aNode! !

!DoubleLinkedListNode methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:14'!
previous
	^previous! !

!DoubleLinkedListNode methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:14'!
previous: aNode
	previous := aNode! !

!DoubleLinkedListNode methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:14'!
value 
	^value! !

!DoubleLinkedListNode methodsFor: 'accessing' stamp: 'AnkeshAnand 12/24/2013 23:15'!
value: anObject 
	value := anObject ! !
